Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/OLD_SingleObjectiveProgrammableProblem.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/OLD_SingleObjectiveProgrammableProblem.cs	(revision 11739)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/OLD_SingleObjectiveProgrammableProblem.cs	(revision 11739)
@@ -0,0 +1,199 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.Programmable {
+  [Item("Programmable Problem (single-objective)", "Represents a single-objective problem that can be programmed.")]
+  [Creatable("Problems")]
+  [StorableClass]
+  public class OLD_SingleObjectiveProgrammableProblem : SingleObjectiveHeuristicOptimizationProblem<ISingleObjectiveEvaluator, ISolutionCreator>, IParameterizedNamedItem, IStorableContent {
+    public string Filename { get; set; }
+
+    public static new Image StaticItemImage {
+      get { return Common.Resources.VSImageLibrary.Script; }
+    }
+
+    public IValueParameter<ISingleObjectiveProblemDefinition> ProblemDefinitionParameter {
+      get { return (IValueParameter<ISingleObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
+    }
+
+    protected IValueParameter<IEncoding> EncodingParameter {
+      get { return (IValueParameter<IEncoding>)Parameters["Encoding"]; }
+    }
+
+    public ISingleObjectiveProblemDefinition ProblemDefinition {
+      get { return ProblemDefinitionParameter.Value; }
+      set { ProblemDefinitionParameter.Value = value; }
+    }
+
+
+    public override IEnumerable<IParameterizedItem> ExecutionContextItems {
+      get { return base.ExecutionContextItems.Concat(new[] { ProblemDefinition.Encoding }); }
+    }
+    protected override IEnumerable<IItem> GetOperators() {
+      return base.GetOperators().Concat(ProblemDefinition.Encoding.Operators);
+    }
+
+    [StorableConstructor]
+    protected OLD_SingleObjectiveProgrammableProblem(bool deserializing) : base(deserializing) { }
+
+    protected OLD_SingleObjectiveProgrammableProblem(OLD_SingleObjectiveProgrammableProblem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEventHandlers();
+    }
+    public OLD_SingleObjectiveProgrammableProblem()
+      : base(new SingleObjectiveEvaluator(), new MultiEncodingCreator()) {
+      Parameters.Add(new ValueParameter<ISingleObjectiveProblemDefinition>("ProblemDefinition", "Defines the problem.", new SingleObjectiveProblemDefinitionScript() { Name = Name }));
+      Parameters.Add(new ValueParameter<IEncoding>("Encoding", "Describes the configuration of the encoding, what the variables are called, what type they are and their bounds if any."));
+
+
+      Operators.Add(new BestScopeSolutionAnalyzer());
+      Operators.Add(new SingleObjectiveAnalyzer());
+      Operators.Add(Evaluator);
+
+      RegisterEventHandlers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OLD_SingleObjectiveProgrammableProblem(this, cloner);
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    // ReSharper disable UnusedMember.Local
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+    // ReSharper restore UnusedMember.Local
+
+    private void RegisterEventHandlers() {
+      ProblemDefinitionParameter.ValueChanged += ProblemDefinitionParameterOnValueChanged;
+      RegisterProblemDefinitionEventHandlers();
+    }
+
+    private void ProblemDefinitionParameterOnValueChanged(object sender, EventArgs eventArgs) {
+      RegisterProblemDefinitionEventHandlers();
+      Parameterize();
+    }
+
+    private void RegisterProblemDefinitionEventHandlers() {
+      //ProblemDefinitionParameter.Value.ProblemDefinitionChanged += ProblemDefinitionChanged;
+      ProblemDefinitionParameter.Value.NameChanged += ProblemDefinitionNameChanged;
+    }
+
+    private void ProblemDefinitionNameChanged(object sender, EventArgs eventArgs) {
+      if (sender != ProblemDefinitionParameter.Value) return;
+      Name = ProblemDefinitionParameter.Value.Name;
+    }
+
+    protected override void OnNameChanged() {
+      base.OnNameChanged();
+      ProblemDefinitionParameter.Value.Name = Name;
+    }
+
+    protected override void OnEvaluatorChanged() {
+      base.OnEvaluatorChanged();
+      Parameterize();
+    }
+
+    protected virtual void ProblemDefinitionChanged(object sender, EventArgs eventArgs) {
+      Parameterize();
+    }
+
+    protected virtual void Parameterize() {
+      var definition = ProblemDefinitionParameter.Value;
+      if (definition == null) return;
+
+      IEncoding encoding = definition.Encoding;
+      SolutionCreator = encoding.SolutionCreator;
+
+      EncodingParameter.Value = encoding;
+      Maximization.Value = definition.Maximization;
+
+      //Evaluator.EncodingParameter.ActualName = EncodingParameter.Name;
+      //Evaluator.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //foreach (var evalOp in Operators.OfType<ISingleObjectiveProgrammableProblemEvaluator>()) {
+      //  evalOp.EncodingParameter.ActualName = EncodingParameter.Name;
+      //  evalOp.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //}
+      //foreach (var analyzeOp in Operators.OfType<ISingleObjectiveProgrammableProblemAnalyzer>()) {
+      //  analyzeOp.EncodingParameter.ActualName = EncodingParameter.Name;
+      //  analyzeOp.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //  analyzeOp.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+      //}
+
+      ConfigureSingleEncodingOperators();
+      UpdateImprovementOperators();
+      UpdateMoveOperators();
+    }
+
+
+    protected virtual void ConfigureSingleEncodingOperators() {
+      foreach (var su in GetOperators().OfType<IRealVectorSwarmUpdater>()) {
+        su.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      }
+    }
+
+    protected virtual void UpdateImprovementOperators() {
+      if (!Operators.Any(x => x is SingleObjectiveImprover))
+        Operators.Add(new SingleObjectiveImprover());
+      //foreach (var improver in Operators.OfType<SingleObjectiveImprover>()) {
+      //  improver.EncodingParameter.ActualName = EncodingParameter.Name;
+      //  improver.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      //  improver.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      //  improver.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+      //}
+    }
+    protected virtual void UpdateMoveOperators() {
+      if (!Operators.Any(x => x is SingleObjectiveMoveGenerator))
+        Operators.Add(new SingleObjectiveMoveGenerator());
+      if (!Operators.Any(x => x is SingleObjectiveMoveEvaluator))
+        Operators.Add(new SingleObjectiveMoveEvaluator());
+      if (!Operators.Any(x => x is SingleObjectiveMoveMaker))
+        Operators.Add(new SingleObjectiveMoveMaker());
+
+      foreach (var generator in Operators.OfType<SingleObjectiveMoveGenerator>()) {
+        generator.EncodingParameter.ActualName = EncodingParameter.Name;
+        //generator.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      }
+      foreach (var evaluator in Operators.OfType<SingleObjectiveMoveEvaluator>()) {
+        evaluator.EncodingParameter.ActualName = EncodingParameter.Name;
+        evaluator.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        //evaluator.ProblemDefinitionParameter.ActualName = ProblemDefinitionParameter.Name;
+      }
+      foreach (var maker in Operators.OfType<SingleObjectiveMoveMaker>()) {
+        maker.EncodingParameter.ActualName = EncodingParameter.Name;
+        maker.MoveQualityParameter.ActualName = Operators.OfType<SingleObjectiveMoveEvaluator>().First().MoveQualityParameter.ActualName;
+        maker.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+      }
+    }
+  }
+}
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiObjectiveAnalyzer.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiObjectiveAnalyzer.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiObjectiveAnalyzer.cs	(revision 11739)
@@ -13,10 +13,6 @@
   [Item("Multi-objective Analyzer", "Calls the Analyze method of the problem definition.")]
   [StorableClass]
-  public class MultiObjectiveAnalyzer : SingleSuccessorOperator, IMultiObjectiveProgrammableProblemAnalyzer {
+  public class MultiObjectiveAnalyzer : SingleSuccessorOperator, IMultiObjectiveAnalysisOperator {
     public bool EnabledByDefault { get { return true; } }
-
-    public ILookupParameter<IMultiObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<IMultiObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
-    }
 
     public ILookupParameter<IEncoding> EncodingParameter {
@@ -32,4 +28,6 @@
     }
 
+    public Action<Individual[], double[][], ResultCollection> AnalyzeAction { get; set; }
+
     [StorableConstructor]
     protected MultiObjectiveAnalyzer(bool deserializing) : base(deserializing) { }
@@ -37,5 +35,4 @@
     public MultiObjectiveAnalyzer() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<IMultiObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleArray>("Qualities", "The qualities of the parameter vector."));
@@ -48,6 +45,4 @@
 
     public override IOperation Apply() {
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null.");
       var encoding = EncodingParameter.ActualValue;
       var results = ResultsParameter.ActualValue;
@@ -58,5 +53,5 @@
 
       var individuals = scopes.Select(encoding.GetIndividual).ToArray();
-      definition.Analyze(individuals, QualitiesParameter.ActualValue.Select(x => x.ToArray()).ToArray(), results);
+      AnalyzeAction(individuals, QualitiesParameter.ActualValue.Select(x => x.ToArray()).ToArray(), results);
       return base.Apply();
     }
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiObjectiveEvaluator.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiObjectiveEvaluator.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/MultiObjectiveEvaluator.cs	(revision 11739)
@@ -32,12 +32,8 @@
   [Item("Multi-objective Evaluator", "Calls the Evaluate method of the problem definition and writes the return value into the scope.")]
   [StorableClass]
-  public class MultiObjectiveEvaluator : SingleSuccessorOperator, IMultiObjectiveProgrammableProblemEvaluator, IStochasticOperator {
+  public class MultiObjectiveEvaluator : SingleSuccessorOperator, IMulitObjectiveEvaluationOperator, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-
-    public ILookupParameter<IMultiObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<IMultiObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
     }
 
@@ -50,4 +46,6 @@
     }
 
+    public Func<Individual, IRandom, double[]> EvaluateFunc { get; set; }
+
     [StorableConstructor]
     protected MultiObjectiveEvaluator(bool deserializing) : base(deserializing) { }
@@ -55,5 +53,4 @@
     public MultiObjectiveEvaluator() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<IMultiObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new LookupParameter<DoubleArray>("Qualities", "The qualities of the parameter vector."));
@@ -66,9 +63,7 @@
     public override IOperation Apply() {
       var random = RandomParameter.ActualValue;
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null.");
       var encoding = EncodingParameter.ActualValue;
       var individual = encoding.GetIndividual(ExecutionContext.Scope);
-      QualitiesParameter.ActualValue = new DoubleArray(definition.Evaluate(random, individual));
+      QualitiesParameter.ActualValue = new DoubleArray(EvaluateFunc(individual, random));
       return base.Apply();
     }
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveAnalyzer.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveAnalyzer.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveAnalyzer.cs	(revision 11739)
@@ -13,10 +13,6 @@
   [Item("Single-objective Analyzer", "Calls the script's Analyze method to be able to write into the results collection.")]
   [StorableClass]
-  public class SingleObjectiveAnalyzer : SingleSuccessorOperator, ISingleObjectiveProgrammableProblemAnalyzer {
+  public sealed class SingleObjectiveAnalyzer : SingleSuccessorOperator, ISingleObjectiveAnalysisOperator, IAnalyzer {
     public bool EnabledByDefault { get { return true; } }
-
-    public ILookupParameter<ISingleObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<ISingleObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
-    }
 
     public ILookupParameter<IEncoding> EncodingParameter {
@@ -32,10 +28,10 @@
     }
 
+    public Action<Individual[], double[], ResultCollection> AnalyzeAction { get; set; }
+
     [StorableConstructor]
-    protected SingleObjectiveAnalyzer(bool deserializing) : base(deserializing) { }
-    protected SingleObjectiveAnalyzer(SingleObjectiveAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    private SingleObjectiveAnalyzer(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveAnalyzer(SingleObjectiveAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public SingleObjectiveAnalyzer() {
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<ISingleObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The quality of the parameter vector."));
@@ -48,6 +44,4 @@
 
     public override IOperation Apply() {
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null");
       var encoding = EncodingParameter.ActualValue;
       var results = ResultsParameter.ActualValue;
@@ -58,5 +52,5 @@
 
       var individuals = scopes.Select(encoding.GetIndividual).ToArray();
-      definition.Analyze(individuals, QualityParameter.ActualValue.Select(x => x.Value).ToArray(), results);
+      AnalyzeAction(individuals, QualityParameter.ActualValue.Select(x => x.Value).ToArray(), results);
       return base.Apply();
     }
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveEvaluator.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveEvaluator.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveEvaluator.cs	(revision 11739)
@@ -32,12 +32,8 @@
   [Item("Single-objective Evaluator", "Calls the script's Evaluate method to get the quality value of the parameter vector.")]
   [StorableClass]
-  public class SingleObjectiveEvaluator : SingleSuccessorOperator, ISingleObjectiveProgrammableProblemEvaluator, IStochasticOperator {
+  public sealed class SingleObjectiveEvaluator : SingleSuccessorOperator, ISingleObjectiveEvaluationOperator, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-
-    public ILookupParameter<ISingleObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<ISingleObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
     }
 
@@ -50,25 +46,22 @@
     }
 
+    public Func<Individual, IRandom, double> EvaluateFunc { get; set; }
+
     [StorableConstructor]
-    protected SingleObjectiveEvaluator(bool deserializing) : base(deserializing) { }
-    protected SingleObjectiveEvaluator(SingleObjectiveEvaluator original, Cloner cloner) : base(original, cloner) { }
+    private SingleObjectiveEvaluator(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveEvaluator(SingleObjectiveEvaluator original, Cloner cloner) : base(original, cloner) { }
     public SingleObjectiveEvaluator() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<ISingleObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the parameter vector."));
     }
 
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new SingleObjectiveEvaluator(this, cloner);
-    }
+    public override IDeepCloneable Clone(Cloner cloner) { return new SingleObjectiveEvaluator(this, cloner); }
 
     public override IOperation Apply() {
       var random = RandomParameter.ActualValue;
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null.");
       var encoding = EncodingParameter.ActualValue;
       var individual = encoding.GetIndividual(ExecutionContext.Scope);
-      QualityParameter.ActualValue = new DoubleValue(definition.Evaluate(random, individual));
+      QualityParameter.ActualValue = new DoubleValue(EvaluateFunc(individual, random));
       return base.Apply();
     }
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveImprover.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveImprover.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveImprover.cs	(revision 11739)
@@ -1,3 +1,25 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Common;
@@ -12,15 +34,7 @@
   [Item("Single-objective Improver", "Improves a solution by calling GetNeighbors and Evaluate of the corresponding problem definition.")]
   [StorableClass]
-  public sealed class SingleObjectiveImprover : SingleSuccessorOperator, ISingleObjectiveImprovementOperator, IStochasticOperator {
-    public IValueLookupParameter<IItem> SolutionParameter {
-      get { return new ValueLookupParameter<IItem>("notused"); }
-    }
-
+  public sealed class SingleObjectiveImprover : SingleSuccessorOperator, INeighborBasedOperator, ISingleObjectiveEvaluationOperator, IStochasticOperator {
     public ILookupParameter<IRandom> RandomParameter {
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-
-    public ILookupParameter<ISingleObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<ISingleObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
     }
 
@@ -49,4 +63,7 @@
     }
 
+    public Func<Individual, IRandom, double> EvaluateFunc { get; set; }
+    public Func<Individual, IRandom, IEnumerable<Individual>> GetNeighborsFunc { get; set; }
+
     [StorableConstructor]
     private SingleObjectiveImprover(bool deserializing) : base(deserializing) { }
@@ -54,5 +71,4 @@
     public SingleObjectiveImprover() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<ISingleObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the parameter vector."));
@@ -69,6 +85,4 @@
     public override IOperation Apply() {
       var random = RandomParameter.ActualValue;
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null.");
       var encoding = EncodingParameter.ActualValue;
       var maximize = MaximizationParameter.ActualValue.Value;
@@ -76,5 +90,5 @@
       var sampleSize = SampleSizeParameter.ActualValue.Value;
       var individual = encoding.GetIndividual(ExecutionContext.Scope);
-      var quality = QualityParameter.ActualValue == null ? definition.Evaluate(random, individual) : QualityParameter.ActualValue.Value;
+      var quality = QualityParameter.ActualValue == null ? EvaluateFunc(individual, random) : QualityParameter.ActualValue.Value;
 
       var count = 0;
@@ -82,6 +96,6 @@
         Individual best = null;
         var bestQuality = quality;
-        foreach (var neighbor in definition.GetNeighbors(random, individual).Take(sampleSize)) {
-          var q = definition.Evaluate(random, neighbor);
+        foreach (var neighbor in GetNeighborsFunc(individual, random).Take(sampleSize)) {
+          var q = EvaluateFunc(neighbor, random);
           count++;
           if (maximize && bestQuality > q || !maximize && bestQuality < q) continue;
@@ -95,4 +109,5 @@
 
       LocalEvaluatedSolutionsParameter.ActualValue = new IntValue(count);
+      QualityParameter.ActualValue = new DoubleValue(quality);
       individual.Copy(ExecutionContext.Scope);
       return base.Apply();
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveEvaluator.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveEvaluator.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveEvaluator.cs	(revision 11739)
@@ -32,12 +32,8 @@
   [Item("Single-objective MoveEvaluator", "Evaluates a parameter vector that results from a move.")]
   [StorableClass]
-  public class SingleObjectiveMoveEvaluator : InstrumentedOperator, ISingleObjectiveMoveOperator, ISingleObjectiveMoveEvaluator, IStochasticOperator {
+  public class SingleObjectiveMoveEvaluator : SingleSuccessorOperator, ISingleObjectiveEvaluationOperator, ISingleObjectiveMoveEvaluator, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-
-    public ILookupParameter<ISingleObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<ISingleObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
     }
 
@@ -54,4 +50,6 @@
     }
 
+    public Func<Individual, IRandom, double> EvaluateFunc { get; set; }
+
     [StorableConstructor]
     protected SingleObjectiveMoveEvaluator(bool deserializing) : base(deserializing) { }
@@ -59,5 +57,4 @@
     public SingleObjectiveMoveEvaluator() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
-      Parameters.Add(new LookupParameter<ISingleObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the parameter vector."));
@@ -69,12 +66,10 @@
     }
 
-    public override IOperation InstrumentedApply() {
+    public override IOperation Apply() {
       var random = RandomParameter.ActualValue;
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null.");
       var encoding = EncodingParameter.ActualValue;
       var individual = encoding.GetIndividual(ExecutionContext.Scope);
-      MoveQualityParameter.ActualValue = new DoubleValue(definition.Evaluate(random, individual));
-      return base.InstrumentedApply();
+      MoveQualityParameter.ActualValue = new DoubleValue(EvaluateFunc(individual, random));
+      return base.Apply();
     }
   }
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveGenerator.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveGenerator.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveGenerator.cs	(revision 11739)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Globalization;
 using System.Linq;
@@ -34,6 +35,5 @@
   [Item("Single-objective MoveGenerator", "Calls the GetNeighbors method of the problem definition to obtain the moves.")]
   [StorableClass]
-  public class SingleObjectiveMoveGenerator : InstrumentedOperator, ISingleObjectiveMoveOperator, IMultiMoveGenerator, IStochasticOperator {
-
+  public class SingleObjectiveMoveGenerator : SingleSuccessorOperator, INeighborBasedOperator, IMultiMoveGenerator, IStochasticOperator {
     public ILookupParameter<IRandom> RandomParameter {
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
@@ -44,11 +44,9 @@
     }
 
-    public ILookupParameter<ISingleObjectiveProblemDefinition> ProblemDefinitionParameter {
-      get { return (ILookupParameter<ISingleObjectiveProblemDefinition>)Parameters["ProblemDefinition"]; }
-    }
-
     public ILookupParameter<IEncoding> EncodingParameter {
       get { return (ILookupParameter<IEncoding>)Parameters["Encoding"]; }
     }
+
+    public Func<Individual, IRandom, IEnumerable<Individual>> GetNeighborsFunc { get; set; }
 
     [StorableConstructor]
@@ -59,5 +57,4 @@
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
       Parameters.Add(new ValueLookupParameter<IntValue>("SampleSize", "The number of moves to sample."));
-      Parameters.Add(new LookupParameter<ISingleObjectiveProblemDefinition>("ProblemDefinition", "The host that holds the problem definition."));
       Parameters.Add(new LookupParameter<IEncoding>("Encoding", "An item that holds the problem's encoding."));
     }
@@ -67,12 +64,10 @@
     }
 
-    public override IOperation InstrumentedApply() {
+    public override IOperation Apply() {
       var random = RandomParameter.ActualValue;
-      var definition = ProblemDefinitionParameter.ActualValue;
-      if (definition == null) throw new InvalidOperationException("Problem definition is null.");
       var sampleSize = SampleSizeParameter.ActualValue.Value;
       var encoding = EncodingParameter.ActualValue;
       var individual = encoding.GetIndividual(ExecutionContext.Scope);
-      var nbhood = definition.GetNeighbors(random, individual).Take(sampleSize).ToList();
+      var nbhood = GetNeighborsFunc(individual, random).Take(sampleSize).ToList();
 
       var moveScopes = new Scope[nbhood.Count];
@@ -83,5 +78,5 @@
       ExecutionContext.Scope.SubScopes.AddRange(moveScopes);
 
-      return base.InstrumentedApply();
+      return base.Apply();
     }
   }
Index: /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveMaker.cs
===================================================================
--- /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveMaker.cs	(revision 11738)
+++ /branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Operators/SingleObjectiveMoveMaker.cs	(revision 11739)
@@ -32,5 +32,5 @@
   [Item("Single-objective MoveMaker", "Applies a move.")]
   [StorableClass]
-  public class SingleObjectiveMoveMaker : InstrumentedOperator, ISingleObjectiveMoveOperator, IMoveMaker {
+  public class SingleObjectiveMoveMaker : InstrumentedOperator, IMoveMaker {
     public ILookupParameter<IEncoding> EncodingParameter {
       get { return (ILookupParameter<IEncoding>)Parameters["Encoding"]; }
